<?php

namespace JUM\YandexTurbo\Feed;

use Zend\Feed\{Writer\Feed, Exception};

class GetFeed extends Feed
{
	/**
	 * @param $type
	 * @param bool $ignoreExceptions
	 * @return mixed|string
	 */
	public function export($type, $ignoreExceptions = false)
	{
		$this->setType(strtolower($type));
		$type = ucfirst($this->getType());
		if ($type !== 'Rss') {
			throw new Exception\InvalidArgumentException('Invalid feed type specified: ' . $type . '.'
				. ' Should be one of "rss" or "atom".');
		}
		$renderClass = 'JUM\\YandexTurbo\Feed\\Rss';
		$renderer = new $renderClass($this);
		if ($ignoreExceptions) {
			$renderer->ignoreExceptions();
		}
		return $renderer->render()->saveXml();
	}
}