<?php

namespace JUM\YandexTurbo\Feed;

use DOMDocument;
use DOMElement;
use Zend\Feed\Writer;

class Rss extends Writer\Renderer\Feed\Rss
{
	/**
	 * @return $this|Writer\Renderer\Feed\Rss
	 */
	public function render()
	{
		$this->dom = new DOMDocument('1.0', $this->container->getEncoding());
		$this->dom->formatOutput = true;
		$this->dom->substituteEntities = false;
		$rss = $this->dom->createElement('rss');
		$this->setRootElement($rss);
		$rss->setAttribute('version', '2.0');
		$rss->setAttribute('xmlns:yandex', 'http://news.yandex.ru');
		$rss->setAttribute('xmlns:media', 'http://search.yahoo.com/mrss/');
		$rss->setAttribute('xmlns:turbo', 'http://turbo.yandex.ru');

		$channel = $this->dom->createElement('channel');
		$rss->appendChild($channel);
		$this->dom->appendChild($rss);
		$this->_setLanguage($this->dom, $channel);
		$this->_setBaseUrl($this->dom, $channel);
		$this->_setTitle($this->dom, $channel);
		$this->_setDescription($this->dom, $channel);
		$this->_setImage($this->dom, $channel);
		$this->_setDateCreated($this->dom, $channel);
		$this->_setDateModified($this->dom, $channel);
		$this->_setLastBuildDate($this->dom, $channel);
		$this->_setGenerator($this->dom, $channel);
		$this->_setLink($this->dom, $channel);
		$this->_setAuthors($this->dom, $channel);
		$this->_setCopyright($this->dom, $channel);
		$this->_setCategories($this->dom, $channel);

		foreach ($this->extensions as $ext) {
			$ext->setType($this->getType());
			$ext->setRootElement($this->getRootElement());
			$ext->setDomDocument($this->getDomDocument(), $channel);
			$ext->render();
		}

		$this->_setPluginId($this->dom, $channel);

		foreach ($this->container as $entry) {
			if ($this->getDataContainer()->getEncoding()) {
				$entry->setEncoding($this->getDataContainer()->getEncoding());
			}
			if ($entry instanceof Writer\Entry) {
				$renderer = new Writer\Renderer\Entry\Rss($entry);
			} else {
				continue;
			}
			if ($this->ignoreExceptions === true) {
				$renderer->ignoreExceptions();
			}
			$renderer->setType($this->getType());
			$renderer->setRootElement($this->dom->documentElement);
			$renderer->render();
			$element = $renderer->getElement();
			$element->setAttribute('turbo', 'true');
			$deep = version_compare(PHP_VERSION, '7', 'ge') ? 1 : true;
			$imported = $this->dom->importNode($element, $deep);
			$channel->appendChild($imported);
		}
		return $this;
	}

	protected function _setPluginId(DOMDocument $dom, DOMElement $root)
	{
		$cmsPlugin = $dom->createElement('turbo:cms_plugin');
		$root->appendChild($cmsPlugin);
		$text = $dom->createTextNode('E2453AD5002B8FC2C690578F11DFD661');
		$cmsPlugin->appendChild($text);
	}
}