<?php

namespace JUM\YandexTurbo\XF\Option;

use XF\Option\AbstractOption;
use XF\Util\Arr;

class CleanRegexpValidator extends AbstractOption
{
	public static function verifyOption(&$value, \XF\Entity\Option $option)
	{
		$output = [];

		if ($value !== '')
		{
			foreach (Arr::stringToArray($value, '/\r?\n/') AS $value)
			{
				if (!\XF\Util\Php::isValidRegex($value))
				{
					$option->error(\XF::phrase('invalid_regular_expression'), $option->option_id);
					return false;
				}
				$output[] = $value;
			}
		}

		$value = implode(PHP_EOL, $output);

		return true;
	}
}